function [Diff_DATA] = S_PProfile (Gen_data,Demand_data,Gen_powerRating, nl, para)
Gen_data=Gen_data/Gen_powerRating;

for i=1:length(Gen_data)
if sign(Gen_data(i))==-1 %Prevents the noised data from going below zero, which is impossible.
        Gen_data(i)=0;
elseif Gen_data(i) > 1
    Gen_data(i) = 1;
end
end

Noise_data = Gen_data+Scn1_Noise(Gen_data, nl) %Adds noise to the data, if desired.
for i=1:length(Noise_data)
    if sign(Noise_data(i))==-1 %Prevents the noised data from going below zero, which is impossible.
        Noise_data(i)=0;
    elseif Noise_data(i) > 1
    Noise_data(i) = 1;
    end
end

Demand_energyTotal = sum(Demand_data)*para.Timestep;
Gen_energyTotal = sum(Gen_data)*para.Timestep; %Normalised energy total
Gen_powerRating =(Demand_energyTotal/Gen_energyTotal)*(para.E_Pen);

%% Electricity Generator Variables

Noise_data = Noise_data*sum(Gen_data)*para.Timestep/(sum(Noise_data)*para.Timestep);
Noise_data=Noise_data*Gen_powerRating; %If the Gen_data is normalised, this always it to be converted to a certain size, which was calculated based on the enrgy penetration value
Diff_DATA = Noise_data-Demand_data;

Diff_DATA = Diff_DATA + Diff_DATA*para.Sizing_factor; %This produces a larger requirement for the system sizing to handle discrepencies in wind power preditions
para.t=(0:length(Diff_DATA)-1)';
para.t=para.t*(para.Timestep)/24;% array for creating timescales for plots which will match the total wind load length

