function [BU_modNum,BU_powerFuel] = Scn1_BU(Gen_powerExtra,BU,para)
global Diff_DATA;

%Back-Up Generator Calculation
%This function uses the technological parameters of the back-up generator
%system to size the system needed to provide enough power to back0up the
%energy storage system. This calculation is based on Gen_powerExtra and
%Gen_energyExtra)

%Assumptions:
%Operation Strategy - this code assumes a high-efficiency "Start-Stop operation stategy
%of maxing all modules, and only using one or so to start on and off.
% This strategy is explained in A Case Study on Offshore Wind Power
% Supply...

%% BU_Backup Power Options
BU_power = zeros(length(Diff_DATA),1); %ES Resevoir %Only way I can make this vector of the right size?
BU_powerFuel = zeros(length(Diff_DATA),1);
BU_energy = zeros(length(Diff_DATA),1);
BU_modNum = zeros(length(Diff_DATA),1);
BU_startTime = 0; %Defines how long is required to bring backup power online (in hours). 0 implies it is instantaneous, such as in scenarios where the BU is the grid. CUrrently Unused


%BU.Unit_P = 1; %Size of each backup generator module
%BU_LHV = 43; %J/m3 of NG
%number = 1.23;
%integ = fix(number);
%fract = abs(number - integ);

BU_modNum_max = ceil(abs(min(Gen_powerExtra(:))/BU.Unit_P));
BU_modCounter = zeros(BU_modNum_max,1);


test = zeros(BU_modNum_max,length(Diff_DATA));
count = zeros(1,length(Diff_DATA));
for i=1:length(Diff_DATA)
    if Gen_powerExtra(i)<0  %if Backup Power is required
        BU_modNum(i) = abs(Gen_powerExtra(i))/BU.Unit_P; %How many modules are required for timestep i          
        BU_modNum_int = fix(BU_modNum(i)); %How many modules run at 100% (Rounds down)
        BU_modNum_frac = abs(BU_modNum(i) - BU_modNum_int); % what is the partload fraction of the remaining module
        
        m=1;
        %This block of code sets up a Module Counter which establishes how
        %long each module has been running for to determine if it can be
        %shut down.
        while ceil(BU_modNum(i))>numel(find(BU_modCounter~=0))
            if BU_modCounter(m)==0
               BU_modCounter(m)=BU.Unit_downtime/para.Timestep;
            end
            m=m+1;
        end
        while ceil(BU_modNum(i))<numel(find(BU_modCounter~=0))&&numel(find(BU_modCounter==1))>0
            if BU_modCounter(m)==1
               BU_modCounter(m)=0;
            end
            m=m+1;
        end
        for m=1:BU_modNum_max
            if BU_modCounter(m)~=1 && BU_modCounter(m)~=0
                BU_modCounter(m)=BU_modCounter(m)-1;
            end
        end
        test(:,i)=BU_modCounter(:);
        count(:,i)=numel(find(BU_modCounter~=0));
        
        if numel(find(BU_modCounter~=0))>BU_modNum_int; %Success. Tested and working
            BU_modNum_int=numel(find(BU_modCounter~=0))-1; %This block sets the number of 100% load modules based on how many are needed and adjusted by the Mod Counter
        end
        %test2(i)=BU_modNum_int;
        [BU_modMin, BU_EffIndex] = min(abs(BU.Eff(:,1)-BU_modNum_frac)); %Basically, determines the index where the module partload fraction fits in the efficiency curve
        [~,BU_EffIndex_Full] = min(abs(BU.Eff(:,1)-1)); %Finds the index of the Full Load efficiency value
        BU_powerFuel(i) = BU_modNum_int*BU.Unit_P/BU.Eff(BU_EffIndex_Full,2)+ BU_modNum_frac*BU.Unit_P/BU.Eff(BU_EffIndex,[2]); %Uses the indexes to extract appropriate efficiencies and applies them to calculate fuel power.        
    end
end

%{
LW=2;
plot(BU.Eff(:,1)*100,BU.Eff(:,2)*100,'LineWidth',LW);
Title_str= ['Load-Efficiency Curve'];
hTitle  = title (Title_str);
hXLabel = xlabel('% Total Load');
hYLabel = ylabel('% Efficiency');
hZLabel = zlabel('ok');

hTitle  = title (''); % REmoves graph titles
set(gca,'FontName', 'Calibri Light' );
set([hTitle, hXLabel, hYLabel, hZLabel], 'FontName','Calibri');
set([gca],'FontSize', 18);
set([hXLabel, hYLabel, hZLabel],'FontSize', 18), 'FontWeight', 'bold';
set(hTitle ,'FontSize'   , 14, 'FontWeight' , 'bold');
export_fig(filename,'-eps','-transparent','-painters');
filename = 'GTEffLoad';
%hleg1 = legend('Wind', 'Demand', 'location', 'NorthEast');
Plot_Settings(filename, Title_str, hXLabel, hYLabel, hZLabel);
hold off;


%hold off;
%}
