function [Gen_powerExtra, Gen_energyExtra, ES_energy, ES_powerData, ES_energyData] = Scn1_Calc(ES, ES_tech, para)
global Diff_DATA;

ES_chargePower = ES(1);
ES_energyMax = ES(2);

%ES_energyMax=CS4_ES2.ES_E;
%ES_chargePower=CS4_ES2.ES_P;
ES_dischargePower = -ES_chargePower; 
ES_energy = zeros(length(Diff_DATA),1); %ES Resevoir %Only way I can make this vector of the right size?
%ES_energyMax = 1000;
ES_energyMin = 0;
ES_energyInitial = para.ES_initialCharge*ES_energyMax; %ES_energyMax/2; %Initial energy quantity in ES at start of simulation
ES_energyData = zeros(length(Diff_DATA),1);
ES_powerData = zeros(length(Diff_DATA),1);

Gen_powerExtra = zeros(length(Diff_DATA),1); %defining the array size... may need to move this into .._Calc.m
Gen_energyExtra = zeros(length(Diff_DATA),1);

%Diff_DATA_mod = Diff_DATA + Diff_DATA*para.Sizing_factor; %This produces a larger requirement for the system sizing to handle discrepencies in wind power preditions
Diff_DATA_mod = Diff_DATA;
%% BU_Backup Power Options
BU_power = zeros(length(Diff_DATA),1); %ES Resevoir %Only way I can make this vector of the right size?
BU_energy = zeros(length(Diff_DATA),1);
BU_startup = 0; %Defines how long is required to bring backup power online (in hours). 0 implies it is instantaneous, such as in scenarios where the BU is the grid. CUrrently Unused

%% Simulation of Power Requirements for ES over time
for i=1:length(Diff_DATA)
    if Diff_DATA_mod(i)>0  %if Wind Power is larger than Demand
        if Diff_DATA_mod(i)<=ES_chargePower %ES_tech.chargeEff isn't included here because the charging power restriction is based on how much total power flows in, even though not as much will actually be stored
            ES_powerData(i)=Diff_DATA_mod(i);
        else
            ES_powerData(i)=ES_chargePower;
            Gen_powerExtra(i) = Diff_DATA_mod(i)-ES_chargePower; %Catalogues all power that is produced that cannot be absorbed by the ES because the charge power isn't high enough           
        end
    else                %if Demand is larger than Wind Power
        if Diff_DATA_mod(i)>=ES_dischargePower %If the demand difference between wind and demand (accounting for discharge efficiency) is less than max discharge
            ES_powerData(i)=Diff_DATA_mod(i); 
        else
            ES_powerData(i)=ES_dischargePower;
            Gen_powerExtra(i)=Diff_DATA_mod(i)-ES_dischargePower;
            %%BU_power(i)=Diff_DATA_mod(i)+ES_dischargePower; %Catalogues how much backup power is required per time step
    
        end
    end
end
for i=1:length(Diff_DATA) %Conversion of Power into Energy
    if ES_powerData(i)>=0
        ES_energyData(i) = ES_powerData(i)*ES_tech.chargeEff*para.Timestep;
    else
        ES_energyData(i) = ES_powerData(i)*(1/ES_tech.dischargeEff)*para.Timestep;
    end
end
%NOTE: Both ES_powerData and ES_energyData does not account for the energy
%that cannot be added/removed due to max or min energy capacity being
%reached.
%ES_energyData = ES_powerData*ES_tech.chargeEff*para.Timestep; %Change in energy per para.Timestep as a function of E=P*t

%% Simulation of Energy Level of ES over time - ES_energy is the current level of the ES resevoir

%ES_energy(1) = ES_energy_1 + ES_energyData(1); %Defining initial energy conditions
for i=1:length(Diff_DATA)
    if i>1
        if ES_energy(i-1)+ ES_energyData(i)>ES_energyMax
            ES_energy(i)= ES_energyMax;
            Gen_powerExtra(i)=Gen_powerExtra(i)+(ES_energy(i-1)+ ES_energyData(i)-ES_energyMax)*(1/ES_tech.chargeEff)/para.Timestep; %This line adds the power requirements of BU or Dump caused by having to provide/dump all excess energy because the max/min capacity of ES was hit
        %Wind_energyExtra(i)= ES_energy(i-1)+ ES_energyData(i)-ES_energyMax;
        elseif ES_energy(i-1)+ ES_energyData(i)<ES_energyMin
            ES_energy(i)= ES_energyMin;
            Gen_powerExtra(i)=Gen_powerExtra(i)+(ES_energy(i-1)+ ES_energyData(i)-ES_energyMin)*(ES_tech.dischargeEff)/para.Timestep;
        %Wind_energyExtra(i)= ES_energy(i-1)+ ES_energyData(i)-ES_energyMin;
        else
            ES_energy(i) = ES_energy(i-1)+ ES_energyData(i);
        end
    else
        if ES_energyInitial + ES_energyData(i)>ES_energyMax
            ES_energy(i)= ES_energyMax;
            Gen_powerExtra(i)=Gen_powerExtra(i)+(ES_energyInitial+ ES_energyData(i)-ES_energyMax)*(1/ES_tech.chargeEff)/para.Timestep; %This line adds the power requirements of BU or Dump caused by having to provide/dump all excess energy because the max/min capacity of ES was hit
        %Wind_energyExtra(i)= ES_energy(i-1)+ ES_energyData(i)-ES_energyMax;
        elseif ES_energyInitial + ES_energyData(i)<ES_energyMin
            ES_energy(i)= ES_energyMin;
            Gen_powerExtra(i)=Gen_powerExtra(i)+(ES_energyInitial+ ES_energyData(i)-ES_energyMin)*(ES_tech.dischargeEff)/para.Timestep;
        %Wind_energyExtra(i)= ES_energy(i-1)+ ES_energyData(i)-ES_energyMin;
        else
            ES_energy(i) = ES_energyInitial + ES_energyData(i);
        end
    end
end

%Gen_powerExtra=Gen_powerExtra+Gen_powerExtra*para.Sizing_factor; %Increases the extra power demand


%{
ES_energy(1) = ES_energy_1 + ES_energyData(1); %Defining initial energy conditions
for i=2:length(Diff_DATA)
    if ES_energy(i-1)+ ES_energyData(i)>ES_energyMax
        ES_energy(i)= ES_energyMax;
        Gen_powerExtra(i)=Gen_powerExtra(i)+(ES_energy(i-1)+ ES_energyData(i)-ES_energyMax)*(1/ES_tech.chargeEff)/para.Timestep; %This line adds the power requirements of BU or Dump caused by having to provide/dump all excess energy because the max/min capacity of ES was hit
        %Wind_energyExtra(i)= ES_energy(i-1)+ ES_energyData(i)-ES_energyMax;
    elseif ES_energy(i-1)+ ES_energyData(i)<ES_energyMin
        ES_energy(i)= ES_energyMin;
        Gen_powerExtra(i)=Gen_powerExtra(i)+(ES_energy(i-1)+ ES_energyData(i)-ES_energyMin)*(ES_tech.dischargeEff)/para.Timestep;
        %Wind_energyExtra(i)= ES_energy(i-1)+ ES_energyData(i)-ES_energyMin;
    else
        ES_energy(i) = ES_energy(i-1)+ ES_energyData(i);
    end
end

%}
for i=1:length(Diff_DATA) %Conversion of Excess power into Excess Energy
    if Gen_powerExtra(i)>0
        Gen_energyExtra(i) = Gen_powerExtra(i)*para.Timestep;
    else
        Gen_energyExtra(i) = Gen_powerExtra(i)*para.Timestep;
    end
end


BU_power = max(Gen_powerExtra(Gen_powerExtra<0)); %%Caclulates total amount of power that is required by backupsources
BU_energy = sum(Gen_energyExtra(Gen_energyExtra<0)); %Claculates total energy that is required by backup sources
Dumped_energy = sum(Gen_energyExtra(Gen_energyExtra>0));

