function [BU_Cost_Cap,BU_Cost_OM_PV,BU_Cost_totalFuel,BU_Cost_GHG, ES_Cost_Cap,ES_Cost_OM_PV] = Scn1_Cost_Base()

global BU_GHG_Cost Project_Lifetime DR
global ES_Cost_chargePower ES_Cost_capacity ES_Cost_OM_Fix ES_Cost_OM_Var 
global BU_modSize BU_eff BU_LHV BU_GHG
global BU_Cost_mod BU_Cost_OM_Fix BU_Cost_OM_Var BU_Cost_Fuel
global Diff_DATA Diff_TIMESTEP;

[BU_modNum,BU_powerFuel] = Scn1_BU(Diff_DATA);

BU_energyFuel = sum(BU_powerFuel)*Diff_TIMESTEP; %MWh of Fuel Consumed
BU_energyEl = abs(sum(Diff_DATA(Diff_DATA<0)))*Diff_TIMESTEP;
%BU_fuel = BU_energyFuel/BU_LHV; %Releases amount of fuel consumed over the simulaton in basic units.
BU_modNumTot = ceil(max(BU_modNum)); %Calculates the total number of modules needed for the simulation
BU_modNumTot = BU_modNumTot+1; %Adds the N+1 in reserve. 

BU_Cost_Cap = BU_Cost_mod*BU_modNumTot;
BU_Cost_OM = BU_Cost_OM_Fix*BU_modNumTot*BU_modSize + BU_energyEl*BU_Cost_OM_Var;

%BU_Cost_yearly = BU_Cost_OM_Fix*BU_modNumTot*BU_modSize + BU_energyEl*BU_Cost_OM_Var + BU_energyFuel*(BU_Cost_fuel+BU_GHG_Cost); %O&M costs + Fuel costs + GHG taxes

[BU_Cost_OM_PV] = PVCalc(DR, Project_Lifetime, BU_Cost_OM); % NPV over the lifetime at the DR (without profits).
[BU_Cost_totalFuel] = PVCalc(DR, Project_Lifetime, BU_energyFuel*BU_Cost_Fuel);
[BU_Cost_GHG] = PVCalc(DR, Project_Lifetime, BU_energyFuel*BU_GHG_Cost);

ES_Cost_Cap = 0;
ES_Cost_OM_PV = 0;
Cost = BU_Cost_Cap+ BU_Cost_OM_PV+BU_Cost_totalFuel+BU_Cost_GHG;

%Plot_Display_CostComp(BU_Cost_Cap, BU_Cost_OM_PV, BU_Cost_totalFuel, BU_Cost_GHG);
%Cost = ES_Cost_cap + BU_Cost_cap + ES_Cost_OM_PV+BU_Cost_OM_PV;
