%function [BU_Cost_Cap,BU_Cost_OM_PV,BU_Cost_totalFuel,BU_Cost_GHG, ES_Cost_Cap,ES_Cost_OM_PV] = Scn1_Cost_Base()

global BU_GHG_Cost Project_Lifetime DR
global ES_Cost_chargePower ES_Cost_capacity ES_Cost_OM_Fix ES_Cost_OM_Var 
global BU_modSize BU_eff BU_LHV BU_GHG
global BU_Cost_mod BU_Cost_OM_Fix BU_Cost_OM_Var BU_Cost_Fuel
global Diff_DATA Diff_TIMESTEP;
global Trans_cableR Trans_cabletype Trans_distance;
%[BU_modNum,BU_powerFuel] = Scn1_BU(Diff_DATA);
%{
BU_energyFuel = sum(BU_powerFuel)*Diff_TIMESTEP; %MWh of Fuel Consumed
BU_energyEl = abs(sum(Diff_DATA(Diff_DATA<0)))*Diff_TIMESTEP;
%BU_fuel = BU_energyFuel/BU_LHV; %Releases amount of fuel consumed over the simulaton in basic units.
BU_modNumTot = ceil(max(BU_modNum)); %Calculates the total number of modules needed for the simulation
BU_modNumTot = BU_modNumTot+1; %Adds the N+1 in reserve. 

BU_Cost_Cap = BU_Cost_mod*BU_modNumTot;
BU_Cost_OM = BU_Cost_OM_Fix*BU_modNumTot*BU_modSize + BU_energyEl*BU_Cost_OM_Var;

%BU_Cost_yearly = BU_Cost_OM_Fix*BU_modNumTot*BU_modSize + BU_energyEl*BU_Cost_OM_Var + BU_energyFuel*(BU_Cost_fuel+BU_GHG_Cost); %O&M costs + Fuel costs + GHG taxes

[BU_Cost_OM_PV] = PVCalc(DR, Project_Lifetime, BU_Cost_OM); % NPV over the lifetime at the DR (without profits).
[BU_Cost_totalFuel] = PVCalc(DR, Project_Lifetime, BU_energyFuel*BU_Cost_Fuel);
[BU_Cost_GHG] = PVCalc(DR, Project_Lifetime, BU_energyFuel*BU_GHG_Cost);
%}
    Trans_Voltage = [66 110 132 150 220 275];
SEKtoEUR=0.123855;
Gen_powerExtra=150;
for v=1:6

for i=1:15
Trans_distance = 0+10*i


[P_dc,S_ac] = Scn1_Trans(Gen_powerExtra,Trans_Voltage(v));

%Cost cooefficient tables for AC and DC, dependant on voltage
Cost_DC_coeff = [5 -0.346 0.408;40 -0.314 0.0618;160 -0.1 0.0164;230 0.079 0.012;300 0.286 0.00969];
Cost_DC_coeff(:,2) =  Cost_DC_coeff(:,2)*1e6;


Cost_AC_coeff = [22	0.284 0.583	6.15;33	0.411 0.596 4.1;45 0.516 0.612 3;66 0.688 0.625 2.05;132 1.971 0.209 1.66;220 3.181 0.11 1.16]
Cost_AC_coeff(:,2) =  Cost_AC_coeff(:,2)*1e6;
Cost_AC_coeff(:,3) =  Cost_AC_coeff(:,3)*1e6;

%Interpolations of cost coefficiencts
[fitAC_A,gof,output] = fit(Cost_AC_coeff(:,1),Cost_AC_coeff(:,2), 'poly1');
fitAC_B = fit(Cost_AC_coeff(:,1),Cost_AC_coeff(:,3), 'linearinterp');
fitAC_C = fit(Cost_AC_coeff(:,1),Cost_AC_coeff(:,4), 'linearinterp');

fitDC_A = fit(Cost_DC_coeff(:,1),Cost_DC_coeff(:,2), 'poly1');
fitDC_B = fit(Cost_DC_coeff(:,1),Cost_DC_coeff(:,3), 'linearinterp');
P=P_dc
S = S_ac

Trans_Cost_ACDC = SEKtoEUR*P_dc*1e6*2 %Costing for two VSC ACDC converters - one on either end of the HVDC cable
Trans_Cost_Trans_DC = SEKtoEUR*(-1.208*1e6+2143*(P_dc*1e6)^0.4473)*2
Trans_Cost_Cable_DC = SEKtoEUR*(fitDC_A(Trans_Voltage(v))+fitDC_B(Trans_Voltage(v))*P_dc*1e6)*Trans_distance

Trans_Cost_Trans_AC = SEKtoEUR*(-1.208*1e6+2143*(S_ac*1e6)^0.4473)*2
Trans_Cost_Cable_AC = SEKtoEUR*(fitAC_A(Trans_Voltage(v))+fitAC_B(Trans_Voltage(v))*exp(fitAC_C(Trans_Voltage(v))*S_ac*1e6/1e8))*Trans_distance

Trans_Cost = [Trans_Cost_Trans_DC Trans_Cost_Cable_DC Trans_Cost_ACDC;Trans_Cost_Trans_AC Trans_Cost_Cable_AC 0]



COST(i,1,:)= Trans_Cost(1,:);
COST(i,2,:)= Trans_Cost(2,:);
Cost_Label(i)=Trans_distance;
end
plotBarStackGroups(COST, Cost_Label)
hTitle  = title (Trans_Voltage(v));
end

%plot(fitDC_B,Cost_DC_coeff(:,1),Cost_DC_coeff(:,3));
%

%{
%Plot
figure;
hBar = bar(1:(numel(CostComp(:,1))),[CostComp]/1000000, 'stacked');

% Adjust the axis limits
%axis([0 13 0 100000]);

% Add a legend
legend('DC', 'SCGT O&M', 'Fuel', 'GHG Tax', 'ORES Capital', 'ORES O&M',-1);

%LW = 2;
%plot(t,ES_energy,'LineWidth',LW);
Title_str= ['Cost breakdown'];
hTitle  = title (Title_str);
hXLabel = xlabel('Case ');
hYLabel = ylabel('Cost (Million )');
hZLabel = zlabel('ok');
hTitle  = title (''); % REmoves graph titles
set(gca,'XTickLabel',{'Base Case', 'Optimisation'});
set(gca,'FontName', 'Calibri Light' );
set([hTitle, hXLabel, hYLabel, hZLabel], 'FontName','Calibri');
set([gca],'FontSize', 18);
set([hXLabel, hYLabel, hZLabel],'FontSize', 18, 'FontWeight', 'bold');
set(hTitle ,'FontSize'   , 24, 'FontWeight' , 'bold');
export_fig(filename,'-eps','-transparent','-painters');

filename = 'CostCompRERC';
%Plot_Settings(filename, Title_str, hXLabel, hYLabel, hZLabel);
hold off;

%}

%Cost = BU_Cost_Cap+ BU_Cost_OM_PV+BU_Cost_totalFuel+BU_Cost_GHG;

%Plot_Display_CostComp(BU_Cost_Cap, BU_Cost_OM_PV, BU_Cost_totalFuel, BU_Cost_GHG);
%Cost = ES_Cost_cap + BU_Cost_cap + ES_Cost_OM_PV+BU_Cost_OM_PV;
