function [Scn_ES] = Scn1_MultiOpt(ES_tech, BU, para)

options = optimset('TolCon',1e-14, 'TolFun',1e-14, 'TolX', 1e-14, 'MaxFunEvals',1500,  'Algorithm', 'sqp', 'Display', 'off'); %Defining the options for our optimisation function 


%The following function calls the optimisation 5 times, each with different
%starting parameters (ES). AFter all 5 simulation runs, it decides which is
%the true min and this value is used as the result.

Scn_ES = Obj_Results;

if strcmp(BU.name, 'None') == 1 %This entire code is for optimising a BU-free ES scenario. Note that there still is a cost for fill the initial ES and for the +1 backup generator.
    exitflag=-2;
    A=0;
    B=0;
    i=1;
   while exitflag==-2
       ES = [A B];
        [ES,place, exitflag]=fmincon(@(ES) Scn1_Cost(ES, ES_tech, BU, para),ES,[],[],[],[],[0 0],[],@(ES) ESonly_con(ES, ES_tech, para),options);
        A = 1*i^3;
        B = i^3*100;
   end

elseif strcmp(ES_tech.name,'None') == 0
    for e=0:5
        [ES]=[e^2*3 e^3*100];
        [place,result(e+1,3), exitflag]= fmincon(@(ES) Scn1_Cost(ES, ES_tech, BU, para),ES,[],[],[],[],[0 0],[],[],options);
        result(e+1,1)= place(1,1);
        result(e+1,2)= place(1,2);
        %result(e+1,:) %DISPLAY
    end
    [minCost,minCostI] = min(result(:,3));
    %A = 'The Min is:' %DISPLAY
    %result(minCostI,:) %DISPLAY
    ES=[result(minCostI,1) result(minCostI,2)];
    Scn_ES.title=ES_tech.shortname;
%UNLESS the ESTECH is set to none, which means there is no ES system, and
%the entire simulation is treated as a basecase scenario (with only BU)
else
    ES = [0 0];
    Scn_ES.title=BU.shortname;
end

[Scn_ES.total,Scn_ES.BU_cap,Scn_ES.BU_OM,Scn_ES.BU_fuel,Scn_ES.BU_GHG,Scn_ES.ES_cap,Scn_ES.ES_fuel,Scn_ES.ES_OM, Scn_ES.BU_OM_conf, Scn_ES.ES_cap_conf,Scn_ES.ES_OM_conf, Scn_ES.BU_unit] = Scn1_Cost(ES, ES_tech, BU, para);
Scn_ES.vector = [Scn_ES.BU_cap Scn_ES.BU_OM Scn_ES.BU_fuel Scn_ES.BU_GHG Scn_ES.ES_cap Scn_ES.ES_OM]';
Scn_ES.BU_cap_conf = BU.Cost_P_conf;
Scn_ES.BU_fuel_conf = BU.Cost_fuel_conf;
Scn_ES.BU_GHG_conf = BU.Cost_GHG_conf;

Scn_ES.ES_P=ES(1,1);
Scn_ES.ES_E=ES(1,2);

%Scn_ES = ES;

end

