%% Core File
tic
%for w = 2:2:20 %This is to simulate multiple wind parks
Wind_powerRating=w;
SizingStorage_Setup;
ES_chargePower = zeros(100,1);
ES_dischargePower = minDiff; % currently discharge is set to the maximum discharge required in order to meet the max load. This is because we want to currently reach a completely independant scenario
E_max = 500;
E_inc = 3;
P_max = 15;
P_inc = 0.2;

BU = ones(E_max/E_inc,P_max/P_inc);
Dump = ones(E_max/E_inc,P_max/P_inc);
Wind_n = ones(E_max/E_inc,P_max/P_inc);
p_placeMax = 1;
e_placeMax = 1;
e=1;

while 1<2     % Creates an infinite while loop, until the Ifs break it.
    p=1;
    while 1<2 
        [Wind_powerExtra, Wind_energyExtra] = SizingStorage_Calc(p*P_inc,ES_dischargePower,e*E_inc);
        BU_energyTotal = sum(Wind_energyExtra(Wind_energyExtra<0));
        Wind_energyDump = sum(Wind_energyExtra(Wind_energyExtra>0));
        BU(e,p) = BU_energyTotal;
        Dump(e,p) = Wind_energyDump;
        Wind_n(e,p) = (Wind_energyTotal - sum(Wind_energyExtra(Wind_energyExtra>0)))/Wind_energyTotal;
        if p >1 && BU(e,p) == BU(e,p-1)
            p_place = p;
            if p_place>p_placeMax
                p_placeMax=p_place;
            end
            break;
        end;   
        p=p+1;
    end
    if e >1 && BU(e,p) == BU(e-1,p)
        e_placeMax = e;
        break;
    end;
    e=e+1;
end

% This block rewrites the arrays, only in the opposite fashion - examining
% E first and then P. This ensures no data is missed. Otherwise, it may
% break too early
p=1;
while 1<2     % Creates an infinite while loop, until the Ifs break it.
e=1;
    while 1<2   
        [Wind_powerExtra, Wind_energyExtra] = SizingStorage_Calc(p*P_inc,ES_dischargePower,e*E_inc);
        BU(e,p) = sum(Wind_energyExtra(Wind_energyExtra<0));
        Dump(e,p) = sum(Wind_energyExtra(Wind_energyExtra>0));
        Wind_n(e,p) = (Wind_energyTotal - sum(Wind_energyExtra(Wind_energyExtra>0)))/Wind_energyTotal;
        if e >1 && BU(e,p) == BU(e-1,p)
            e_place = e;
            if e_place>e_placeMax
                e_placeMax=e_place;
            end
            break;
        end
        e=e+1;
    end
    p=p+1;
    if p > p_placeMax
        break;
    end;
end
p=1;
for p=1:1:p_placeMax   %used to repopulate cells that were cut-off because of the break, in order to make a nice square array. This allows it to graph nicely. Note that all the addtional cells filled are repetions 
    for e=1:1:e_placeMax
        if  BU(e,p) == 1;
        	[Wind_powerExtra, Wind_energyExtra] = SizingStorage_Calc(p*P_inc,ES_dischargePower,e*E_inc);
        	BU(e,p) = sum(Wind_energyExtra(Wind_energyExtra<0));
        	Dump(e,p) = sum(Wind_energyExtra(Wind_energyExtra>0));
            Wind_n(e,p) = (Wind_energyTotal - sum(Wind_energyExtra(Wind_energyExtra>0)))/Wind_energyTotal;
        end
    end
end

%Setup code to create a scatterplot showing optimal ES
BU_min=max(max(BU(e_placeMax,p_placeMax)));
c=1;
for p=1:1:p_placeMax
    for e=1:1:e_placeMax
        if BU(e,p) == BU_min
            if c ==1 || e ~= ES_lowBU(c-1,1)% This loop removes repetitve ES setups that simply have more power for the same BU. remove this loop, and all of the ES options that yield lowest BU will become available.
                ES_lowBU(c,1) = e;
                ES_lowBU(c,2) = p;
                
                %if c==1 || Wind_n(e,p)> Wind_n(ES_lowBU(c-1,1),ES_lowBU(c-1,2)) %This Code picks
                %the ES setup that has the LOWEST dump energy, assuming
                %that this saves the most energy. In reality, causes the ES
                %setup to be waaaay bigger than it probably should be,
                %since cost isn't taken into accout
                if c==1 || ((e+p)<(ES_lowBU(c-1,1)+ES_lowBU(c-1,2))) %Instead, this function just looks for the lowest combination. Not perfect. SHould fix.
                    ES_opt=[e,p];                  
                end
                
                c = c+1;
            end                
            break;            
        end
        
    end
end




toc
%Wind_powerRating = 8;
%SizingStorage_Setup;
%[Wind_powerExtra, Wind_energyExtra,ES_powerData, ES_energy] = SizingStorage_Calc(ES_opt(1,2)*P_inc,ES_dischargePower,ES_opt(1,1)*E_inc); %Lines up the optimal ES options for graphing
%SizingStorage_Display;