global Diff_DATA;
% THink about creating m file 'modules' that will take different data file
% formats and restructure them into the universal format, which can then be
% sent to the regular code.
%This function sets up the Demand and Base Power Production Modules

%% Base Power Production Module - Wind Power
Gen_File = 'Wind Power Curve.xlsx';
Demand_File = 'Demand Curve.xlsx';
sheet = 1;
xlRange = 'D:D';
Gen_test= xlsread(Gen_File,sheet);
[m,n]= size(Gen_test);
for i=1:m
    hold=Gen_test(i,:)';
    Gen_hold((i-1)*length(hold)+1:i*length(hold),1)=hold;
end
Gen_timeStep =0.25; % This is set depending on the data in Gen_file. In this case, each data point is 15 minutes
Gen_data=decimate(Gen_hold,para.Timestep/Gen_timeStep); % decimates the data to the Timestep of choice.
for i=1:length(Gen_data)
if sign(Gen_data(i))==-1 %Prevents the noised data from going below zero, which is impossible.
        Gen_data(i)=0;
end
end
%{
Noise_data = Gen_data+Scn1_Noise(Gen_data); %Adds noise to the data, if desired.
for i=1:length(Noise_data)
    if sign(Noise_data(i))==-1 %Prevents the noised data from going below zero, which is impossible.
        Noise_data(i)=0;
    end
end
%}


%% Demand Profile Module - Offshore Platform

Demand_timeStep =1; %Represents number of hours that each data point from demandData represents
Demand_data = decimate(xlsread(Demand_File,sheet),para.Timestep/Demand_timeStep); %decimates this data into the timestep of choice
Demand_dataLength = length(Demand_data);
Demand_powerRating = 70;
Demand_data=Demand_data*Demand_powerRating;
Demand_energyTotal = sum(Demand_data)*para.Timestep; %Defines\the total wind energy available over the data set time-span.

%% Electricity Generator Variables

Gen_energyTotal = sum(Gen_data)*para.Timestep; %Normalised energy total
Gen_powerRating =(Demand_energyTotal/Gen_energyTotal)*(para.E_Pen);
Gen_powerRating = round(Gen_powerRating); %we determine the average power rating required to produce enough year energy to equal a factor (energy generation penetration factor) of the demand
Gen_data=Gen_data*Gen_powerRating; %If the Gen_data is normalised, this always it to be converted to a certain size, which was calculated based on the enrgy penetration value
Gen_energyTotal = sum(Gen_data)*Gen_timeStep; %Defines\the total generation energy available over the data set time-span.


%%

Diff_DATA = Gen_data-Demand_data;
Diff_DATA = Diff_DATA + Diff_DATA*para.Sizing_factor; %This produces a larger requirement for the system sizing to handle discrepencies in wind power preditions
para.t=(0:length(Diff_DATA)-1)';
para.t=para.t*(para.Timestep)/24;% array for creating timescales for plots which will match the total wind load length

%% - Graph Generation

%LW=1;
%{
plot(t*24,Demand_data, 'Linewidth', LW);
Title_str= ['Demand Curve'];
hTitle  = title (Title_str);
hXLabel = xlabel('Time (Hour)');
hYLabel = ylabel('Demand (MW)');
hZLabel = zlabel('ok');
%hleg1 = legend('Wind', 'Demand', 'location', 'NorthEast');
Plot_Settings(filename, Title_str, hXLabel, hYLabel, hZLabel);

xmin = 0;
xmax = 48;
ymin = 55;
ymax = 75;
axis([xmin xmax ymin ymax])
%hold off;
%}

%{
plot(t,Gen_data, 'Linewidth', LW);
Title_str= ['Wind Power Curve'];
hTitle  = title (Title_str);
hXLabel = xlabel('Time (Day)');
hYLabel = ylabel('Production (MW)');
hZLabel = zlabel('ok');
set(gca,'FontName', 'Helvetica' );
set([hTitle, hXLabel, hYLabel, hZLabel], 'FontName','AvantGarde');
filename = 'WindCurve';
%hleg1 = legend('Wind', 'Demand', 'location', 'NorthEast');

hTitle  = title (''); % REmoves graph titles
set(gca,'FontName', 'Calibri Light' );
set([hTitle, hXLabel, hYLabel, hZLabel], 'FontName','Calibri');
set([gca],'FontSize', 18);
set([hXLabel, hYLabel, hZLabel],'FontSize', 18), 'FontWeight', 'bold';
set(hTitle ,'FontSize'   , 14, 'FontWeight' , 'bold');
export_fig(filename,'-eps','-transparent','-painters');

%Plot_Settings(filename, Title_str, hXLabel, hYLabel, hZLabel);

xmin = 0;
xmax = 365;
ymin = 0;
ymax = 150;
axis([xmin xmax ymin ymax])
%hold off;
%}

%% Cable-to-Consumer - This situation is only relevant for far-from-shore situations, because otherwise the cable would be sized based on the maximum load demand out of necessity
%Cable_power = 10;
%% ES_Energy Storage Variables
%ES_chargeEff = 0.8;
%ES_dischargeEff= 0.8;