%ES = [ES_chargePower ES_dischargePower ES_energyMax];

global Diff_DATA;

para=Obj_Para;
tic
%Scn1_Para;
toc
tic
Scn1_Setup;
toc






%% Basic Comparison Case
%{
% Base Case Scenario
BU1 = BU_SCGT; % Sets SCGT as the BU system of choice
[ES_tech] = ES_None; %Sets up 'None' as the ES of choice.
CS1_base = Scn1_MultiOpt(ES_tech, BU1, para);

% ES Tech 1 Scenario -
[ES_tech] = ES_PHS; %Sets up PHS as the ES of choice.
CS1_ES1 = Scn1_MultiOpt(ES_tech, BU1, para);

% ES Tech 2 Scenario -
[ES_tech] = ES_CAES; %Sets up PHS as the ES of choice.
CS1_ES2 = Scn1_MultiOpt(ES_tech, BU1, para);

%Comparative Analysis
filename = 'CS1_CompGraph';
err = 'yes';
Analysis_Comp (CS1_base, CS1_ES1, CS1_ES2, filename, err);
%}
%% Cost Extremes Comparison Case
%{
%Worst Case (Highest ES cost, lowest BU cost)

% Sets SCGT as the BU system of choice, but at the lower threshold of the
% BU cost confidence bands.
BU = BU_SCGT; 
BU2 = Scn1_Conf(BU, -1); %Sets the cost confidence bands (ranging between -1 and +1, or -100% and +100%

ES_tech = ES_None; %Sets up 'None' as the ES of choice.
CS2_base = Scn1_MultiOpt(ES_tech, BU2, para);

% ES Tech 1 Scenario -
ES_tech = ES_PHS; %Sets up PHS as the ES of choice.
ES_tech = Scn1_Conf(ES_tech, 1);
CS2_ES1 = Scn1_MultiOpt(ES_tech, BU2, para);

% ES Tech 2 Scenario -
ES_tech = ES_CAES; %Sets up PHS as the ES of choice.
ES_tech = Scn1_Conf(ES_tech, 1);
CS2_ES2 = Scn1_MultiOpt(ES_tech, BU2, para);

%Comparative Analysis
filename = 'CS2_CompGraph';
err = 'no';
Analysis_Comp (CS2_base, CS2_ES1, CS2_ES2, filename, err);


%Best Case (Lowest ES cost, highest BU cost)

% Sets SCGT as the BU system of choice, but at the higher threshold of the
% BU cost confidence bands.
BU = BU_SCGT; 
BU3 = Scn1_Conf(BU, 1); %Sets the cost confidence bands (ranging between -1 and +1, or -100% and +100%

ES_tech = ES_None; %Sets up 'None' as the ES of choice.
CS3_base = Scn1_MultiOpt(ES_tech, BU3, para);

% ES Tech 1 Scenario -
ES_tech = ES_PHS; %Sets up PHS as the ES of choice.
ES_tech = Scn1_Conf(ES_tech, -1);
CS3_ES1 = Scn1_MultiOpt(ES_tech, BU3, para);

% ES Tech 2 Scenario -
ES_tech = ES_CAES; %Sets up PHS as the ES of choice.
ES_tech = Scn1_Conf(ES_tech, -1);
CS3_ES2 = Scn1_MultiOpt(ES_tech, BU3, para);

%Comparative Analysis
filename = 'CS3_CompGraph';
Analysis_Comp (CS3_base, CS3_ES1, CS3_ES2, filename, err);
%}

%% Only ES
%Testing the ES_Only Simulation
%{
BU = BU_None;
%BU.Cost_fuel = BU.Cost_fuel*9; 

[ES_tech] = ES_PHS; %Sets up PHS as the ES of choice.
CS4_ES1 = Scn1_MultiOpt(ES_tech, BU, para);
CS4_ES1.title = ES_tech.shortname;
filename = 'CS4_ES1';
Analysis_Single (CS4_ES1, filename);

[ES_tech] = ES_CAES; %Sets up PHS as the ES of choice.
CS4_ES2 = Scn1_MultiOpt(ES_tech, BU, para);
CS4_ES2.title = ES_tech.shortname;
filename = 'CS4_ES2';
Analysis_Single (CS4_ES2, filename);

filename = 'CS4_PEGraph';
Analysis_ESCompPE(CS4_ES1, CS4_ES2, filename);
%}
%% Sensitivity Analyses
%% Break Even Points

%{
BU = BU_SCGT;

SF =2;

%Fuel Prices
S_prop_name = 'Cost_fuel';
ES_tech = ES_PHS;
[CS5_base, CS5_ES1, CS5_SFv1] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
ES_tech = ES_CAES;
[CS5_base, CS5_ES2, CS5_SFv2] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);

%GHG Taxes
S_prop_name = 'GHG_Cost';
ES_tech = ES_PHS;
[CS6_base, CS6_ES1, CS6_SFv1] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
ES_tech = ES_CAES;
[CS6_base, CS6_ES2, CS6_SFv2] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);

%}
%{
%The following breakevens are for lowering properties, which is why SF is
%-ve
BU = BU_SCGT;
SF = -0.1;
%ES Capital (Power)
S_prop_name = 'Cost_P'
ES_tech = ES_PHS
[CS7_base, CS7_ES1, CS7_SFv1] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
ES_tech = ES_CAES
[CS7_base, CS7_ES2, CS7_SFv2] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);

%ES Capital (Capacity)
S_prop_name = 'Cost_E'
ES_tech = ES_PHS
[CS8_base, CS8_ES1, CS8_SFv1] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
ES_tech = ES_CAES
[CS8_base, CS8_ES2, CS8_SFv2] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
%}
%{
%ES Capital (Power + Capacity)
S_prop_name = 'Cost_P + E'
i = 1;
ES_tech.name = 'None';
CS_base = Scn1_MultiOpt(ES_tech, BU, para);
CS9_ES1 = Obj_Results;
CS9_ES2 = Obj_Results;


ES_tech = ES_PHS
Cost_P_hold = ES_tech.Cost_P;
Cost_E_hold = ES_tech.Cost_E;
    while true
        ES_tech.Cost_P = Cost_P_hold + Cost_P_hold*SF*i;
        ES_tech.Cost_E = Cost_E_hold + Cost_E_hold*SF*i;
        ES_data = Scn1_MultiOpt(ES_tech, BU, para);
        CS9_ES1 = S_pullCosts(CS9_ES1,ES_data,i);
        CS9_SFv1(i,1)= SF*i;        
        %if ES_data.total < CS_base.total; break; end
        if SF*i<=-1; break; end
        i=i+1
    end
%}
    %{
i = 1;
ES_tech = ES_CAES
Cost_P_hold = ES_tech.Cost_P;
Cost_E_hold = ES_tech.Cost_E;
    while true
        ES_tech.Cost_P = Cost_P_hold + Cost_P_hold*SF*i;
        ES_tech.Cost_E = Cost_E_hold + Cost_E_hold*SF*i;
        ES_data = Scn1_MultiOpt(ES_tech, BU, para);
        CS9_ES2 = S_pullCosts(CS9_ES2,ES_data,i);
        CS9_SFv2(i,1)= SF*i;        
       % if ES_data.total < CS_base.total; break; end
        if SF*i<=-1; break; end
        i=i+1
    end
%}
%{
%DR - Discount Rate
SF =2;
S_prop_name = 'DR';
ES_tech = ES_PHS;
[CS5_base, CS5_ES1, CS5_SFv1] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
ES_tech = ES_CAES;
[CS5_base, CS5_ES2, CS5_SFv2] = Scn1_BreakEven(ES_tech, BU, para,SF,S_prop_name);
%}

%% Fuel/GHG emissions
%These two sensitivities are lumped together because they are very related
%since they depend on the same variables (amount of fuel used).
%There is only point to raise the prices, since at default no ES is used,
%and we are interested to when this will come to pass.
%{
BU = BU_SCGT;
ES_tech = ES_PHS;
%BU.Cost_fuel = BU.Cost_fuel+BU.Cost_fuel*0.8;
%ES_tech.Cost_E = ES_tech.Cost_E*0.55;
ES = [77 CS4_ES1.ES_E];
[Scn_ES.total,Scn_ES.BU_cap,Scn_ES.BU_OM,Scn_ES.BU_fuel,Scn_ES.BU_GHG,Scn_ES.ES_cap,Scn_ES.ES_fuel,Scn_ES.ES_OM, Scn_ES.BU_OM_conf, Scn_ES.ES_cap_conf,Scn_ES.ES_OM_conf, Scn_ES.BU_unit] = Scn1_Cost(ES, ES_tech, BU, para)
%CS_test = Scn1_MultiOpt(ES_tech, BU, para);
%}
%{
BU = BU_SCGT;
S_itSize = 1; %Sets the size of the sensitivity iterations 
S_itMin = 14; %sets the starting point of iterations
S_itMax = 24; %sets the number of iterations
ES_tech = ES_PHS;
[CS5_basefuel1,CS5_baseGHG1,CS5_ES1_fuel,CS5_ES1_GHG, CS5_SFv1] = S_FuelGHG(S_itSize,S_itMin, S_itMax, ES_tech, BU, para);
filename = 'CS_S_ES1FuelCost';
prop = 'total';
Analysis_S_FuelGHG(prop,CS5_basefuel1,CS5_baseGHG1,CS5_ES1_fuel, CS5_ES1_GHG, CS5_SFv1, filename);

filename = 'CS_S_ES1FuelES';
Analysis_S_FuelGHG_yy(CS5_basefuel1,CS5_ES1_fuel, CS5_SFv1, filename);
filename = 'CS_S_ES1GHGES';
Analysis_S_FuelGHG_yy(CS5_baseGHG1,CS5_ES1_GHG, CS5_SFv1, filename);

%}
%{
BU = BU_SCGT;
S_itSize = 0.1; %Sets the size of the sensitivity iterations 
S_itMin = 0; %sets the starting point of iterations
S_itMax = 1.2; %sets the number of iterations
ES_tech = ES_CAES;
[CS5_basefuel2,CS5_baseGHG2,CS5_ES2_fuel,CS5_ES2_GHG, CS5_SFv2] = S_FuelGHG(S_itSize,S_itMin, S_itMax, ES_tech, BU, para);
filename = 'CS_S_ES2FuelCost';
prop = 'total';
Analysis_S_FuelGHG(prop,CS5_basefuel2,CS5_baseGHG2,CS5_ES2_fuel, CS5_ES2_GHG, CS5_SFv2, filename);
filename = 'CS_S_ES2FuelES';
Analysis_S_FuelGHG_yy(CS5_basefuel2,CS5_ES2_fuel, CS5_SFv2, filename);
filename = 'CS_S_ES2GHGES';
Analysis_S_FuelGHG_yy(CS5_baseGHG2,CS5_ES2_GHG, CS5_SFv2, filename);
%}
%% Sensitivies for the capital costs of ES Tech
%[ES_tech] = ES_None; %Sets up 'None' as the ES of choice.
%{
S_itSize = -0.1; %Sets the size of the sensitivity iterations 
S_itMin = 0; %sets the starting point of iterations
S_itMax = -1; %sets the number of iterations
ES_tech = ES_PHS;
[CS_base1,CS_ES1_P,CS_ES1_E, CS_ES1_PE, CS_SFv1] = S_ESCapital(S_itSize,S_itMin, S_itMax, ES_tech, BU, para);
ES_tech = ES_CAES;
[CS_base2,CS_ES2_P,CS_ES2_E, CS_ES2_PE, CS_SFv2] = S_ESCapital(S_itSize,S_itMin, S_itMax, ES_tech, BU, para);

filename = 'CS_S_ESCostGraph';
prop = 'total';
Analysis_Sens(prop,CS_base1, CS_ES1_P, CS_ES1_E, CS_ES1_PE, CS_ES2_P, CS_ES2_E, CS_ES2_PE, CS_SFv1, filename)
%}

%% DR increase
%{
S_itSize = 0.01; %Sets the size of the sensitivity iterations 
S_itMin = 0.10; %sets the starting point of iterations
S_itMax = 0.20; %sets the number of iterations

%Base Case Scenario
BU = BU_SCGT; % Sets SCGT as the BU system of choice
[ES_tech] = ES_None; %Sets up 'None' as the ES of choice.
ES = [0 0];
[CS6_base, CS6_SFv] = S_DR(S_itSize,S_itMin, S_itMax, ES_tech, BU, para, ES);

BU = BU_None;
[ES_tech] = ES_PHS; %Sets up PHS as the ES of choice.
ES = [CS4_ES1.ES_P CS4_ES1.ES_E];
[CS6_ES1] = S_DR(S_itSize,S_itMin, S_itMax, ES_tech, BU, para, ES);

[ES_tech] = ES_CAES; %Sets up PHS as the ES of choice.
ES = [CS4_ES2.ES_P CS4_ES2.ES_E];
[CS6_ES2] = S_DR(S_itSize,S_itMin, S_itMax, ES_tech, BU, para, ES);

filename = 'CS6_DR';
prop = 'total';
Analysis_DR (prop,CS6_base, CS6_ES1, CS6_ES2, CS6_SFv, filename);

%}
%% Random WInd Profile
nl = 1;
Diff_DATA2 = S_PProfile (Gen_data,Demand_data,Gen_powerRating, nl, para);

%% Basic Comparison Case
Diff_DATA = Diff_DATA2; 

% Base Case Scenario
BU1 = BU_SCGT; % Sets SCGT as the BU system of choice
[ES_tech] = ES_None; %Sets up 'None' as the ES of choice.
CS7_base = Scn1_MultiOpt(ES_tech, BU1, para);

% ES Tech 1 Scenario -
[ES_tech] = ES_PHS; %Sets up PHS as the ES of choice.
CS8_ES1 = Scn1_MultiOpt(ES_tech, BU1, para);

% ES Tech 2 Scenario -
[ES_tech] = ES_CAES; %Sets up PHS as the ES of choice.
CS8_ES2 = Scn1_MultiOpt(ES_tech, BU1, para);

%Comparative Analysis
filename = 'CS7_CompGraph';
err = 'yes';
Analysis_Comp (CS7_base, CS8_ES1, CS8_ES2, filename, err);
%}

%% Only ES
%Testing the ES_Only Simulation

BU = BU_None;

[ES_tech] = ES_PHS; %Sets up PHS as the ES of choice.
CS8_ES1 = Scn1_MultiOpt(ES_tech, BU, para);
CS8_ES1.title = ES_tech.shortname;
filename = 'CS7_ES1';
Analysis_Single (CS8_ES1, filename);

[ES_tech] = ES_CAES; %Sets up PHS as the ES of choice.
CS8_ES2 = Scn1_MultiOpt(ES_tech, BU, para);
CS8_ES2.title = ES_tech.shortname;
filename = 'CS7_ES2';
Analysis_Single (CS8_ES2, filename);

filename = 'CS7_PEGraph';
Analysis_ESCompPE(CS8_ES1, CS8_ES2, filename);
%}
