function [P_dc,S_ac] = Scn1_Trans(Gen_powerExtra,V)
global Trans_cableR Trans_cabletype Trans_distance  Cable_File Cable_File_V;
%This function sizes the transmission equipment for the model, connecting
%the system to the grid. First, based on distance from the grid, an
%evaluation shall be performed on whether

Trans_maxPower = abs(min(Gen_powerExtra(:)));

P_loss_factor=0.03;

P_load=Trans_maxPower;
P_loss=P_loss_factor/(1-P_loss_factor)*P_load

%l=Trans_distance;
l=Trans_distance;
resist=1.94808e-8; %in Ohm-meters @ 60 C
A= 300; %area in mm^2
%Dc= 37.9; %diameter of conductor, mm
Dc=37.9;
s= 87.3; %distance (axis-to-axis) of conductors, mm

%DC Cable
R_dc = l*1000*resist/(A*1e-6)


%[x,y] = rqe2(R_dc,-V*1e3,P_load*1e6) % FIX THIS BULLSHIT
%I=min(x,y)
I=sqrt(P_loss*1e6/R_dc)
P_t = P_loss + P_load
It=(P_t*1e6)/(V*1e3)
P_dc=I*V*1e-3

%AC cable
f=50; %AC frequency in HZ
k = 1; %Shape Factor of cable
xs = sqrt((8*pi*f/R_dc)*1e-7*k);
ys=xs^4/(192+0.8*xs^4);
yp=ys*(Dc/s)^2*(0.312*(Dc/s)^2+1.18/(ys+0.27));
R_ac = R_dc*(1+ys+yp)

[x,y] = rqe2(R_ac,-V*1e3,P_load*1e6/3);
I=min(x,y)
P_ac=3*V*I*1e-3 %Total real power sent through cables in MW. Assuming V is per one phase...

cap=0.26;%the capacitance of the cable, in microF/km
%Ic=2*pi*f*cap*V/sqrt(3)*1e-6
%Reactive Power calculation
Q_ac=l*2*pi*f*cap*V^2*1e-6
S_ac=sqrt(P_ac^2+Q_ac^2)



end

