global Gen_DATALENGTH;
global BU_modSize BU_eff;

%Back-Up Generator Calculation
%This function uses the technological parameters of the back-up generator
%system to size the system needed to provide enough power to back0up the
%energy storage system. This calculation is based on Gen_powerExtra and
%Gen_energyExtra)

%Assumptions:
%Operation Strategy - this code assumes a high-efficiency "Start-Stop operation stategy
%of maxing all modules, and only using one or so to start on and off.
% This strategy is explained in A Case Study on Offshore Wind Power
% Supply...

%% BU_Backup Power Options
BU_power = zeros(Gen_DATALENGTH,1); %ES Resevoir %Only way I can make this vector of the right size?
BU_powerFuel = zeros(Gen_DATALENGTH,1);
BU_energy = zeros(Gen_DATALENGTH,1);
BU_modNum = zeros(Gen_DATALENGTH,1);
BU_startTime = 0; %Defines how long is required to bring backup power online (in hours). 0 implies it is instantaneous, such as in scenarios where the BU is the grid. CUrrently Unused


%BU_modSize = 1; %Size of each backup generator module
%BU_LHV = 43; %J/m3 of NG
%number = 1.23;
%integ = fix(number);
%fract = abs(number - integ);


for i=1:Gen_DATALENGTH
    if Gen_powerExtra(i)<0  %if Backup Power is required
        
        BU_modNum(i) = abs(Gen_powerExtra(i))/BU_modSize; %How many modules are required for timestep i
        BU_modNum_int = fix(BU_modNum(i)); %How many modules run at 100%
        BU_modNum_frac = abs(BU_modNum(i) - BU_modNum_int); % what is the partload fraction of the remaining module
        [BU_modMin, BU_effIndex] = min(abs(BU_eff(:,1)-BU_modNum_frac)); %
        [~,a] = min(abs(BU_eff(:,1)-1));
        BU_powerFuel(i) = BU_modNum_int*BU_modSize/BU_eff(a,[2])+ BU_modNum_frac/BU_eff(BU_effIndex,[2]);
        
    end
end